package geo.profile;

import geo.profile.data.PerfilSQLiteHelper;
import geo.profile.receiver.AlarmReceiverFin;
import geo.profile.receiver.AlarmReceiverInicio;
import geo.profile.view.CrearPerfilIntroducirNombreActivity;
import geo.profile.view.EditarPerfilActivity;
import geo.profile.view.EliminarPerfilActivity;

import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.bluetooth.BluetoothAdapter;
import android.content.Context;
import android.content.Intent;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.media.AudioManager;
import android.net.ConnectivityManager;
import android.net.Uri;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.provider.Settings;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
//import android.widget.Toast;

public class GeoProfileActivity extends Activity {
	
	int count = 0;
	
	PerfilSQLiteHelper bd;
	Integer idPerfil;
	Perfil p[];
	
	private final Integer REQUEST_ENABLE_BT = 1;
	BluetoothAdapter mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
	
	AlarmManager am;
	
	//Variables para conocer los estados anteriores
	boolean vibrador = false;
	boolean silencio = false;
	Integer volumen = -1;
	boolean wifi = false;
	boolean tres_g = false;
	boolean bluetooth =false;
	boolean modo_avion = false;
	
	//Conocer el estado de los desvos de llamada es un trabajo de investigacin que no se
	//ha podido completar dada su gran dificultad
//	boolean desvio_siempre;
//	String telefono_siempre;
//	boolean desvio_ocupada;
//	String telefono_ocupada;
//	boolean desvio_sin_respuesta;
//	String telefono_sin_respuesta;
//	String retraso;
//	boolean desvio_sin_conexion;
//	String telefono_sin_conexion;
	
	//Conocer el estado de las aplicaciones de mensajera instantnea no es posible
//	boolean gtalk;
//	boolean whatsapp;
//	boolean facebook_msn;
	
	
	
    /** Called when the activity is first created. */
    @SuppressLint("SimpleDateFormat")
	@Override
    public void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);
    	setContentView(R.layout.main);
    	
        //Creamos la base de datos
        bd = new PerfilSQLiteHelper(this, "DBPerfil", null, 1);
        p = bd.getAllPerfiles();
        
        //Actualizamos la base de datos
//        SQLiteDatabase db = bd.getWritableDatabase();
//        bd.onUpgrade(db, 3, 4);
        
        //Cerramos la base de datos
//        bd.close();
        
        //Botones
	    Button btncrearPerfil = (Button)findViewById(R.id.BtnCrearPerfil);
	    Button btneditarPerfil = (Button)findViewById(R.id.BtnEditarPerfil);
	    Button btneliminarPerfil = (Button)findViewById(R.id.BtnEliminarPerfil);
	    Button btnSalir = (Button)findViewById(R.id.BtnSalir);
	    
	    //Botn Crear Perfil
	    btncrearPerfil.setOnClickListener(new OnClickListener() {
			
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				Intent intent = new Intent(GeoProfileActivity.this,CrearPerfilIntroducirNombreActivity.class);
				
				startActivity(intent);
			}
		});
	    
	    //Botn Editar Perfil
	    btneditarPerfil.setOnClickListener(new OnClickListener() {
			
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				Intent intent = new Intent(GeoProfileActivity.this,EditarPerfilActivity.class);
				
				startActivity(intent);
			}
		});

	    //Botn Eliminar Perfil
	    btneliminarPerfil.setOnClickListener(new OnClickListener() {
	
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				Intent intent = new Intent(GeoProfileActivity.this,EliminarPerfilActivity.class);
				
				startActivity(intent);
			}
		});
	    
	    //Botn Salir
	    btnSalir.setOnClickListener(new OnClickListener() {
			
			public void onClick(View arg0) {
				finish();
			}
		});
    }
    
    protected void onActivityResult (int requestCode, int resultCode, Intent data)
    {
      if ((requestCode == REQUEST_ENABLE_BT) && (resultCode == RESULT_OK))
      {
        boolean isEnabling = mBluetoothAdapter.enable();
        if (!isEnabling)
        {
          // an immediate error occurred - perhaps the bluetooth is already on?
        }
        else if (mBluetoothAdapter.getState() == BluetoothAdapter.STATE_TURNING_ON)
        {
          // the system, in the background, is trying to turn the Bluetooth on
          // while your activity carries on going without waiting for it to finish;
          // of course, you could listen for it to finish yourself - eg, using a
          // ProgressDialog that checked mBluetoothAdapter.getState() every x
          // milliseconds and reported when it became STATE_ON (or STATE_OFF, if the
          // system failed to start the Bluetooth.)
        }
      }
    }
    
    //Mtodo para transformar los das de la semana de la BD a nmeros
    
    ArrayList<Integer> obtenerDiasSemanaNumero(String dias){
    	
    	ArrayList<Integer> array_dias_numero = new ArrayList<Integer>();
    	
    	String dias_repetir_sin_corchetes = dias.substring(1, dias.length() - 1);
		String [] split = dias_repetir_sin_corchetes.split(", ");
	
		for(int j = 0; j < split.length; j++){
			if(split[j].equals("Lunes")){
				array_dias_numero.add(2);
			}else if(split[j].equals("Martes")){
				array_dias_numero.add(3);
			}else if(split[j].equals("Miercoles")){
				array_dias_numero.add(4);
			}else if(split[j].equals("Jueves")){
				array_dias_numero.add(5);
			}else if(split[j].equals("Viernes")){
				array_dias_numero.add(6);
			}else if(split[j].equals("Sabado")){
				array_dias_numero.add(7);
			}else if(split[j].equals("Domingo")){
				array_dias_numero.add(1);
			}
		}
		
		return array_dias_numero;
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		
		p = bd.getAllPerfiles();
		
		realizarCambios(p);
	}

	@Override 
	protected void onPause() {

	   super.onPause();
	   
	   p = bd.getAllPerfiles();
		
		realizarCambios(p);

	}

	@Override 
	protected void onRestart() {

	   super.onRestart();
	   
	   p = bd.getAllPerfiles();
		
		realizarCambios(p);

	}
	
	void realizarCambios(Perfil []p){
		for(int i = 0; i < p.length; i++){
        	
        	//Declaraciones necesarias para repetir poe das
        	
        	String dias_repetir;
        	
        	ArrayList<Integer> array_repetir = new ArrayList<Integer>();
        	
        	Calendar cal = new GregorianCalendar();
        	Integer dia = cal.get(Calendar.DAY_OF_WEEK);
        	
        	//Por hora

        	if(p[i].getPorHora() == 1){
        		
        		if(p[i].getDiasRepeticionHoras() != null){
        			dias_repetir = p[i].getDiasRepeticionHoras();
        			
        			array_repetir = obtenerDiasSemanaNumero(dias_repetir);
            		
            		if(array_repetir.contains(dia)){	//Coincide con el da de la semana
            			
            			//Actualizamos el valor de todas las opciones:
        		        
        		        if(((AudioManager) getSystemService(AUDIO_SERVICE)).getRingerMode() == AudioManager.RINGER_MODE_VIBRATE){
        		        	vibrador = true;
        		        }else if(((AudioManager) getSystemService(AUDIO_SERVICE)).getRingerMode() == AudioManager.RINGER_MODE_SILENT){
        		        	silencio = true;
        		        }
        		    	volumen = ((AudioManager) getSystemService(AUDIO_SERVICE)).getStreamVolume(AudioManager.STREAM_RING);
        		    	wifi = ((WifiManager) getSystemService(WIFI_SERVICE)).isWifiEnabled();
        		    	if(((ConnectivityManager) getSystemService(CONNECTIVITY_SERVICE)).getActiveNetworkInfo()!=null){
        		    		tres_g = ((ConnectivityManager) getSystemService(CONNECTIVITY_SERVICE)).getActiveNetworkInfo().isConnected();
        		    	}
        		    	if(mBluetoothAdapter != null){
        		    		bluetooth = mBluetoothAdapter.isEnabled();
        				}
        		    	if(Settings.System.getInt(getContentResolver(), Settings.System.AIRPLANE_MODE_ON, 0) == 1){
        		    		modo_avion = true;
        				}
                		
                		//Hora de inicio
                    	String inicio = p[i].getHoraInicio();
                    	String[] h_inicio = null;
                		String hora_inicio = null;
                		String minuto_inicio = null;
                    	
                    	if(inicio != null){
                    		h_inicio = inicio.split(":");
                    		hora_inicio = h_inicio[0];
                    		minuto_inicio = h_inicio[1];
                    		
                    		// Alarm manager - magic thing that does what we need
                            am = (AlarmManager) getSystemService(Context.ALARM_SERVICE);
                            // Intent for our  BroadcastReceiver 
                            Intent intent = new Intent(this, AlarmReceiverInicio.class);
                            
                            intent.putExtra("vibrador", p[i].getVibrador());
                            intent.putExtra("volumen", p[i].getVolumen());
                            intent.putExtra("wifi", p[i].getWifi());
                            intent.putExtra("tres_g", p[i].getTresG());
                            intent.putExtra("bluetooth", p[i].getBluetooth());
                            intent.putExtra("modo_avion", p[i].getModoAvion());
                            
                            intent.putExtra("desvio_siempre", p[i].getDesvioSiempre());
                            intent.putExtra("telefono_siempre", p[i].getTelefonoSiempre());
                            intent.putExtra("desvio_ocupada", p[i].getDesvioOcupada());
                            intent.putExtra("telefono_ocupada", p[i].getTelefonoOcupada());
                            intent.putExtra("desvio_sin_conexion", p[i].getDesvioSinConexion());
                            intent.putExtra("telefono_sin_conexion", p[i].getTelefonoSinConexion());
                            intent.putExtra("desvio_sin_respuesta", p[i].getDesvioSinRespuesta());
                            intent.putExtra("telefono_sin_respuesta", p[i].getTelefonoSinRespuesta());
                            intent.putExtra("retraso", p[i].getRetraso());
                            
                            intent.putExtra("whatsapp", p[i].getWhatsApp());
                            intent.putExtra("facebook_msn", p[i].getFacebookMSN());
                            intent.putExtra("gtalk", p[i].getGTalk());
                            
                            intent.putExtra("vibrador_anterior", vibrador);
                            intent.putExtra("silencio_anterior", silencio);
                            intent.putExtra("volumen_anterior", volumen);
                            intent.putExtra("wifi_anterior", wifi);
                            intent.putExtra("tres_g_anterior", tres_g);
                            intent.putExtra("bluetooth_anterior", bluetooth);
                            intent.putExtra("modo_avion_anterior", modo_avion);
                            
                            // PendingIntent for AlarmManager 
                            PendingIntent pendingIntent = PendingIntent.getBroadcast(this, 0,
                                    intent, PendingIntent.FLAG_CANCEL_CURRENT );
                            // Just in case we have already set up AlarmManager,
                            // we do cancel.
                            am.cancel(pendingIntent);

                            //Some simple code to define time of notification:
                            Calendar calInicio = Calendar.getInstance();
                        	calInicio.set(Calendar.HOUR_OF_DAY, Integer.parseInt(hora_inicio));
                        	calInicio.set(Calendar.MINUTE, Integer.parseInt(minuto_inicio));
                            Date stamp =  calInicio.getTime();
                            stamp.setHours(Integer.parseInt(hora_inicio));
                            stamp.setMinutes(Integer.parseInt(minuto_inicio));
                            stamp.setSeconds(0);

                            // In case it's too late notify user today
                            if(stamp.getTime() < System.currentTimeMillis())
                                stamp.setTime(stamp.getTime() + AlarmManager.INTERVAL_DAY);
                                    
                            // Set one-time alarm
                            am.set(AlarmManager.RTC_WAKEUP, stamp.getTime(), pendingIntent);
                        	
                    	}
                    	
                    	//Hora de fin
                    	String fin = p[i].getHoraFin();
                    	String[] h_fin = null;
                		String hora_fin = null;
                    	String minuto_fin = null;
                    	
                    	if(fin != null){
                    		h_fin = fin.split(":");
                    		hora_fin = h_fin[0];
                        	minuto_fin = h_fin[1];
                        	
                        	// Alarm manager - magic thing that does what we need
                            am = (AlarmManager) getSystemService(Context.ALARM_SERVICE);
                            // Intent for our  BroadcastReceiver 
                            Intent intent = new Intent(this, AlarmReceiverFin.class);
                            
                            intent.putExtra("vibrador_anterior", vibrador);
                            intent.putExtra("silencio_anterior", silencio);
                            intent.putExtra("volumen_anterior", volumen);
                            
                            intent.putExtra("wifi_anterior", wifi);
                            intent.putExtra("tres_g_anterior", tres_g);
                            intent.putExtra("bluetooth_anterior", bluetooth);
                            intent.putExtra("modo_avion_anterior", modo_avion);
                            
                            // PendingIntent for AlarmManager 
                            PendingIntent pendingIntent = PendingIntent.getBroadcast(this, 0,
                                    intent, PendingIntent.FLAG_CANCEL_CURRENT );
                            // Just in case we have already set up AlarmManager,
                            // we do cancel.
                            am.cancel(pendingIntent);

                            //Some simple code to define time of notification:
                            Calendar calInicio = Calendar.getInstance();
                        	calInicio.set(Calendar.HOUR_OF_DAY, Integer.parseInt(hora_fin));
                        	calInicio.set(Calendar.MINUTE, Integer.parseInt(minuto_fin));
                            Date stamp =  calInicio.getTime();
                            stamp.setHours(Integer.parseInt(hora_fin));
                            stamp.setMinutes(Integer.parseInt(minuto_fin));
                            stamp.setSeconds(0);

                            // In case it's too late notify user today
                            if(stamp.getTime() < System.currentTimeMillis())
                                stamp.setTime(stamp.getTime() + AlarmManager.INTERVAL_DAY);
                                    
                            // Set one-time alarm
                            am.set(AlarmManager.RTC_WAKEUP, stamp.getTime(), pendingIntent);
                    	}
                    	
            		}
            	}
        		
        	}
        	
        	//Por localizacin
        	
        	if(p[i].getPorGps() == 1){
        		if(p[i].getDiasRepeticionGps() != null){
        			dias_repetir = p[i].getDiasRepeticionGps();
        			
        			array_repetir = obtenerDiasSemanaNumero(dias_repetir);
            		
            		if(array_repetir.contains(dia)){	//Coincide con el da de la semana
            			
            			final Perfil perfil = p[i];
            	    	
//            	    	final Context theContext = this.getApplicationContext();

            	    	LocationManager locationManager = (LocationManager) this.getSystemService(Context.LOCATION_SERVICE);

            	    	LocationListener locationListener = new LocationListener() {

            	    		public void onLocationChanged(Location location) {
            	    			
//            	    			Double nuevaLatitud = location.getLatitude();
//            	    			Double nuevaLongitud = location.getLongitude();
//
//            	    			String nuevaLatitudString= Double.toString(nuevaLatitud);
//            	    			String nuevaLongitudString = Double.toString(nuevaLongitud);
            	    		
//            	    			Toast.makeText(GeoProfileActivity.this,"New location is detected:" + count + "->("+ nuevaLatitudString + "," + nuevaLongitudString+")",Toast.LENGTH_SHORT).show();
            	    			
            	    			count++;
            	    			
            	    			Double latitud;
            	    			Double longitud;
            	    			Double radio;
            	    			
        	    				latitud = perfil.getLatitud();
        	    				longitud = perfil.getLongitud();
        	    				radio = perfil.getRadio();
        	    				
        	    				Location locP = new Location(perfil.getNombre());
        	    				locP.setLatitude(latitud);
        	    				locP.setLongitude(longitud);
        	    				
        	    				double metros = location.distanceTo(locP);
        	    				
//        	    				Toast.makeText(GeoProfileActivity.this,"Metros: "+metros+ " Radio: "+radio,Toast.LENGTH_SHORT).show();
        	    				
        	    				if(metros <= radio){
        	    					
        	    					//Actualizamos el valor de todas las opciones:
        	    			        
        	    			        if(((AudioManager) getSystemService(AUDIO_SERVICE)).getRingerMode() == AudioManager.RINGER_MODE_VIBRATE){
        	    			        	vibrador = true;
        	    			        }else if(((AudioManager) getSystemService(AUDIO_SERVICE)).getRingerMode() == AudioManager.RINGER_MODE_SILENT){
        	    			        	silencio = true;
        	    			        }
        	    			    	volumen = ((AudioManager) getSystemService(AUDIO_SERVICE)).getStreamVolume(AudioManager.STREAM_RING);
        	    			    	wifi = ((WifiManager) getSystemService(WIFI_SERVICE)).isWifiEnabled();
        	    			    	if(((ConnectivityManager) getSystemService(CONNECTIVITY_SERVICE)).getActiveNetworkInfo()!=null){
        	    			    		tres_g = ((ConnectivityManager) getSystemService(CONNECTIVITY_SERVICE)).getActiveNetworkInfo().isConnected();
        	    			    	}
        	    			    	if(mBluetoothAdapter != null){
        	    			    		bluetooth = mBluetoothAdapter.isEnabled();
        	    					}
        	    			    	if(Settings.System.getInt(getContentResolver(), Settings.System.AIRPLANE_MODE_ON, 0) == 1){
        	    			    		modo_avion = true;
        	    					}
        	    					
//        	    					Toast.makeText(GeoProfileActivity.this,"Latitud y longitud coinciden con la del perfil "+perfil.getNombre(),Toast.LENGTH_SHORT).show();
        	    					
        	    					//Wifi
        	    					if(perfil.getWifi() == 1) {	//Activar Wifi
        	    						if(!wifi){
        	    							((WifiManager) getSystemService(WIFI_SERVICE)).setWifiEnabled(true);
        	    						}
        	    					} else {	//Desactivar Wifi
        	    						if(wifi){
        	    							((WifiManager) getSystemService(WIFI_SERVICE)).setWifiEnabled(false);
        	    						}
        	    					}
        	    					
        	    					//Tres_G
        	    					Boolean enabled;
        							if(perfil.getTresG() == 1){
        	    						//Activar 3g
        								if(!tres_g){
        		    						enabled = true;
        		        					final ConnectivityManager conman = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        		        				    Class<?> conmanClass;
        		    						try {
        		    							conmanClass = Class.forName(conman.getClass().getName());
        		    							final Field iConnectivityManagerField = conmanClass.getDeclaredField("mService");
        		    							iConnectivityManagerField.setAccessible(true);
        		    							final Object iConnectivityManager = iConnectivityManagerField.get(conman);
        		    							final Class<?> iConnectivityManagerClass = Class.forName(iConnectivityManager.getClass().getName());
        		    							final Method setMobileDataEnabledMethod = iConnectivityManagerClass.getDeclaredMethod("setMobileDataEnabled", Boolean.TYPE);
        		    							setMobileDataEnabledMethod.setAccessible(true);
        		    							setMobileDataEnabledMethod.invoke(iConnectivityManager, enabled);
        		    						} catch (ClassNotFoundException e1) {
        		    							// TODO Auto-generated catch block
        		    							e1.printStackTrace();
        		    						} catch (SecurityException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									} catch (NoSuchFieldException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									} catch (IllegalArgumentException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									} catch (IllegalAccessException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									} catch (NoSuchMethodException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									} catch (InvocationTargetException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									}
        								}
        	    					}else{
        	    						//Desactivar3g
        	    						if(tres_g){
        		    						enabled = false;
        		        					final ConnectivityManager conman = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        		        				    Class<?> conmanClass;
        		    						try {
        		    							conmanClass = Class.forName(conman.getClass().getName());
        		    							final Field iConnectivityManagerField = conmanClass.getDeclaredField("mService");
        		    							iConnectivityManagerField.setAccessible(true);
        		    							final Object iConnectivityManager = iConnectivityManagerField.get(conman);
        		    							final Class<?> iConnectivityManagerClass = Class.forName(iConnectivityManager.getClass().getName());
        		    							final Method setMobileDataEnabledMethod = iConnectivityManagerClass.getDeclaredMethod("setMobileDataEnabled", Boolean.TYPE);
        		    							setMobileDataEnabledMethod.setAccessible(true);
        		    							setMobileDataEnabledMethod.invoke(iConnectivityManager, enabled);
        		    						} catch (ClassNotFoundException e1) {
        		    							// TODO Auto-generated catch block
        		    							e1.printStackTrace();
        		    						} catch (SecurityException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									} catch (NoSuchFieldException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									} catch (IllegalArgumentException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									} catch (IllegalAccessException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									} catch (NoSuchMethodException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									} catch (InvocationTargetException e) {
        										// TODO Auto-generated catch block
        										e.printStackTrace();
        									}
        	    						}
        	    					}
        							
        	    					//Bluetooth
        							if(perfil.getBluetooth() == 1) {
        								//Activar bluetooth
        								if(!bluetooth){
        									BluetoothAdapter mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();   
        									if(mBluetoothAdapter != null){
        										mBluetoothAdapter.enable();
        									}
        								}
        							} else {
        								//Desactivar bluetooth
        								if(bluetooth){
        									BluetoothAdapter mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        									if(mBluetoothAdapter != null){
        										mBluetoothAdapter.disable();
        									}
        								}
        							}
        							
        	    					//Modo avion
        	    					if(perfil.getModoAvion() == 1){
        	    						//Activar Modo Avion
        	    						if(modo_avion == false){
        	    							Settings.System.putInt(getContentResolver(),Settings.System.AIRPLANE_MODE_ON, 1);
        	    							//Broadcast Intent para informar
        	    					        Intent intent = new Intent(Intent.ACTION_AIRPLANE_MODE_CHANGED);
        	    					        intent.putExtra("state", modo_avion);
        	    					        sendBroadcast(intent);

        	    						}
        	    					}else{
        	    						//Desactivar Modo Avion
        	    						if(modo_avion == true){
        	    							Settings.System.putInt(getContentResolver(),Settings.System.AIRPLANE_MODE_ON, 0);
        	    							//Broadcast Intent para informar
        	    					        Intent intent = new Intent(Intent.ACTION_AIRPLANE_MODE_CHANGED);
        	    					        intent.putExtra("state", modo_avion);
        	    					        sendBroadcast(intent);
        	    					        restaurarValores();

        	    						}
        	    					}
        	    					
        	    					//Sonido
        	    					//Vibrador y Volumen
        	    					if(perfil.getVibrador() == 0 && perfil.getVolumen() == 0) {
        	    						if(!silencio){
        	    							((AudioManager) getSystemService(AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_SILENT);
        	    						}
        	    					}else if(perfil.getVibrador() == 0 && perfil.getVolumen() != 0) {
        	    						((AudioManager) getSystemService(AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_NORMAL);
        	    						((AudioManager) getSystemService(AUDIO_SERVICE)).setStreamVolume(AudioManager.STREAM_RING, perfil.getVolumen(), AudioManager.FLAG_SHOW_UI);
        	    					} else if(perfil.getVibrador() == 1) {
        	    						if(!vibrador){
        	    							((AudioManager) getSystemService(AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_VIBRATE);
        	    						}
        	    					}
        	    					
        	    					//Tono de llamada (no implementado en esta version)
        	    					
        	    					//Contestador (es lo mismo que el desvo de llamadas)
        	    					
        	    					//Desvo de llamadas (En ninguno de los casos se comprueba el estado anterior ya que 
        	    					//es un trabajo de investigacin que no se ha podido completar dada su gran dificultad.
        	    					//Por ello se activan y desactivan independientemente del estado anterior.
        	    					//Comentamos el caso en el que hay que desactivarlo para que no salga constantemente el dilogo informando.    					
        	    					//Desvio Siempre
        	    					if(perfil.getDesvioSiempre() == 1){
        	    						//Activar desvio siempre (si no est activado)
        	    						String numero = perfil.getTelefonoSiempre();
        	    						String callForwardString = "**21*"+numero+"#";    
        	    						Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
        	    						Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
        	    						intentCallForward.setData(uri2);                                
        	    						startActivity(intentCallForward); 
        	    						
        	    					}else{
//            	    						//Desactivar desvio siempre (si est activado)
//            	    						String callForwardString = "##21#";    
//            	    						Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//            	    						Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//            	    						intentCallForward.setData(uri2);                                
//            	    						startActivity(intentCallForward); 
        	    					}
        	    					//Desvio Ocupada
        	    					if(perfil.getDesvioOcupada() == 1){
        	    						//Activar desvio ocupada (si no est activado)
        	    						String numero = perfil.getTelefonoOcupada();
        	    						String callForwardString = "**67*"+numero+"#";    
        	    						Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
        	    						Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
        	    						intentCallForward.setData(uri2);                                
        	    						startActivity(intentCallForward); 
        	    					}else{
//            	    						//Desactivar desvio ocupada (si est activado)
//            	    						String callForwardString = "##67#";    
//            	    						Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//            	    						Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//            	    						intentCallForward.setData(uri2);                                
//            	    						startActivity(intentCallForward); 
        	    					}
        	    					//Desvio Sin Respuesta
        	    					if(perfil.getDesvioSinRespuesta() == 1){
        	    						//Activar desvio sin respuesta (si no est activado)
        	    						String numero = perfil.getTelefonoSinRespuesta();
        	    						String retraso = perfil.getRetraso();
        	    						String callForwardString = "**61*"+numero+"**"+retraso+"#";    
        	    						Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
        	    						Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
        	    						intentCallForward.setData(uri2);                                
        	    						startActivity(intentCallForward); 
        	    					}else{
//            	    						//Desactivar desvio sin respuesta (si est activado)
//            	    						String callForwardString = "##61#";    
//            	    						Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//            	    						Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//            	    						intentCallForward.setData(uri2);                                
//            	    						startActivity(intentCallForward); 
        	    					}
        	    					//Desvio Sin Conexion
        	    					if(perfil.getDesvioSinConexion() == 1){
        	    						//Activar desvio sin conexion (si no est activado)
        	    						String numero = perfil.getTelefonoSinConexion();
        	    						String callForwardString = "**62*"+numero+"#";    
        	    						Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
        	    						Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
        	    						intentCallForward.setData(uri2);                                
        	    						startActivity(intentCallForward); 
        	    					}else{
//            	    						//Desactivar desvio sin conexion (si est activado)
//            	    						String callForwardString = "##62#";    
//            	    						Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//            	    						Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//            	    						intentCallForward.setData(uri2);                                
//            	    						startActivity(intentCallForward); 
        	    					}
        	    					
        	    					//Mensajera instantnea
        	    					//GTalk (No es posible interactuar con la aplicacin)
        	    					if(perfil.getGTalk() == 1){
        	    						//Activar GTalk
        	    					}else{
        	    						//Desactivar GTalk
        	    					}
        	    					//WhatsApp (No es posible interactuar con la aplicacin)
        	    					if(perfil.getWhatsApp() == 1){
        	    						//Activar WhatsApp
        	    					}else{
        	    						//Desactivar WhatsApp
        	    					}
        	    					//Facebook MSN (No es posible interactuar con la aplicacin)
        	    					if(perfil.getFacebookMSN() == 1){
        	    						//Activar Facebook MSN
        	    					}else{
        	    						//Desactivar Facebook MSN
        	    					}

        	    				}else{
        	    					//Reestablecer los valores que haba antes de coincidir con la localizacion
        	    					
        	    					restaurarValores();
        	    					
        	    				}
            	    	
            	    		}
            	    	
            	    		public void onStatusChanged(String provider, int status, Bundle extras) {
            	    	
//            	    			Toast.makeText(theContext, "onStatusChanged", Toast.LENGTH_SHORT).show();
            	    	
            	    		}
            	    	
            	    		public void onProviderEnabled(String provider) {
            	    	
//            	    			Toast.makeText(theContext, "onProviderEnabled", Toast.LENGTH_SHORT).show();
            	    	
            	    		}
            	    	
            	    		public void onProviderDisabled(String provider) {
            	    	
//            	    			Toast.makeText(theContext, "onProviderDisabled", Toast.LENGTH_SHORT).show();
            	    	
            	    		}

            	    	};
            	    	
            	    	// usando GPS, 30.000 milisegundos = 30 segundos
            	    	locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 30000, 0, locationListener);

            	    	// using cell tower and wi-fi
            	    	//locationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, 0, 0, locationListener);

            		}
        		}
        	}
       	}
	}
	
	void restaurarValores(){
		//Wifi
		if(wifi){	//Estaba activado
			((WifiManager) getSystemService(WIFI_SERVICE)).setWifiEnabled(true);
		}else{		//Estaba desactivado
			((WifiManager) getSystemService(WIFI_SERVICE)).setWifiEnabled(false);
		}
		
		//Tres_G
		Boolean enabled;
		if(tres_g){ //Estaba activado
			enabled = true;
			final ConnectivityManager conman = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		    Class<?> conmanClass;
			try {
				conmanClass = Class.forName(conman.getClass().getName());
				final Field iConnectivityManagerField = conmanClass.getDeclaredField("mService");
				iConnectivityManagerField.setAccessible(true);
				final Object iConnectivityManager = iConnectivityManagerField.get(conman);
				final Class<?> iConnectivityManagerClass = Class.forName(iConnectivityManager.getClass().getName());
				final Method setMobileDataEnabledMethod = iConnectivityManagerClass.getDeclaredMethod("setMobileDataEnabled", Boolean.TYPE);
				setMobileDataEnabledMethod.setAccessible(true);
				setMobileDataEnabledMethod.invoke(iConnectivityManager, enabled);
			} catch (ClassNotFoundException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (SecurityException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchFieldException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchMethodException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InvocationTargetException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}else{	//Estaba desactivado
			enabled = false;
			final ConnectivityManager conman = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		    Class<?> conmanClass;
			try {
				conmanClass = Class.forName(conman.getClass().getName());
				final Field iConnectivityManagerField = conmanClass.getDeclaredField("mService");
				iConnectivityManagerField.setAccessible(true);
				final Object iConnectivityManager = iConnectivityManagerField.get(conman);
				final Class<?> iConnectivityManagerClass = Class.forName(iConnectivityManager.getClass().getName());
				final Method setMobileDataEnabledMethod = iConnectivityManagerClass.getDeclaredMethod("setMobileDataEnabled", Boolean.TYPE);
				setMobileDataEnabledMethod.setAccessible(true);
				setMobileDataEnabledMethod.invoke(iConnectivityManager, enabled);
			} catch (ClassNotFoundException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (SecurityException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchFieldException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchMethodException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InvocationTargetException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		//Bluetooth
		if(bluetooth){	//Estaba activado
			BluetoothAdapter mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();   
			if(mBluetoothAdapter != null){
				mBluetoothAdapter.enable();
			}
		} else {	//Estaba desactivado
			BluetoothAdapter mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
			if(mBluetoothAdapter != null){
				mBluetoothAdapter.disable();
			}
		}
		
		//Modo avion
		if(modo_avion){	//Estaba activado
			Settings.System.putInt(getContentResolver(),Settings.System.AIRPLANE_MODE_ON, 1);
			//Broadcast Intent para informar
	        Intent intent = new Intent(Intent.ACTION_AIRPLANE_MODE_CHANGED);
	        intent.putExtra("state", modo_avion);
	        sendBroadcast(intent);

		}else{	//Estaba desactivado
			Settings.System.putInt(getContentResolver(),Settings.System.AIRPLANE_MODE_ON, 0);
			//Broadcast Intent para informar
	        Intent intent = new Intent(Intent.ACTION_AIRPLANE_MODE_CHANGED);
	        intent.putExtra("state", modo_avion);
	        sendBroadcast(intent);
		}
		
		//Sonido
		//Vibrador y Volumen
		if(silencio){	//Estaba en modo silencio
			((AudioManager) getSystemService(AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_SILENT);
		}else{	//Estaba en modo normal
			((AudioManager) getSystemService(AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_NORMAL);
			((AudioManager) getSystemService(AUDIO_SERVICE)).setStreamVolume(AudioManager.STREAM_RING, volumen, AudioManager.FLAG_SHOW_UI);
		}
		if(vibrador){	//Estaba en modo vibrador
			((AudioManager) getSystemService(AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_VIBRATE);
		}else {	//Estaba en modo normal
			((AudioManager) getSystemService(AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_NORMAL);
			((AudioManager) getSystemService(AUDIO_SERVICE)).setStreamVolume(AudioManager.STREAM_RING, volumen, AudioManager.FLAG_SHOW_UI);
		}
		
		//Tono de llamada (no implementado en esta version)
		
		//Contestador (es lo mismo que el desvo de llamadas)
//			
		//Desvo de llamadas (No se restaura al valor anterior dado que no es posible conocer el
		//estado anterior
		//Desvio Siempre
//			if(desvio_siempre){
//				//Activar desvio siempre (si no est activado)
//				String numero = telefono_siempre;
//				String callForwardString = "**21*"+numero+"#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				startActivity(intentCallForward); 
//				
//			}else{
//				//Desactivar desvio siempre (si est activado)
//				String callForwardString = "##21#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				startActivity(intentCallForward); 
//				
//			}
//			//Desvio Ocupada
//			if(desvio_ocupada){
//				//Activar desvio ocupada (si no est activado)
//				String numero = telefono_ocupada;
//				String callForwardString = "**67*"+numero+"#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				startActivity(intentCallForward); 
//			}else{
//				//Desactivar desvio ocupada (si est activado)
//				String callForwardString = "##67#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				startActivity(intentCallForward); 
//			}
//			//Desvio Sin Respuesta
//			if(desvio_sin_respuesta){
//				//Activar desvio sin respuesta (si no est activado)
//				String numero = telefono_sin_respuesta;
//				String callForwardString = "**61*"+numero+"**"+retraso+"#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				startActivity(intentCallForward); 
//			}else{
//				//Desactivar desvio sin respuesta (si est activado)
//				String callForwardString = "##61#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				startActivity(intentCallForward); 
//			}
//			//Desvio Sin Conexion
//			if(desvio_sin_conexion){
//				//Activar desvio sin conexion (si no est activado)
//				String numero = telefono_sin_conexion;
//				String callForwardString = "**62*"+numero+"#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				startActivity(intentCallForward); 
//			}else{
//				//Desactivar desvio sin conexion (si est activado)
//				String callForwardString = "##62#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);                                
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				startActivity(intentCallForward); 
//			}
		
		//Mensajera instantnea (No se restaura el estado anterior dado que no se puede conocer)
//			//GTalk
//			if(gtalk){	//Estaba activado
//				//Activar GTalk
//			}else{
//				//Desactivar GTalk
//			}
//			//WhatsApp
//			if(whatsapp){	//Estaba activado
//				//Activar WhatsApp
//			}else{
//				//Desactivar WhatsApp
//			}
//			//Facebook MSN
//			if(facebook_msn){	//Estaba activado
//				//Activar Facebook MSN
//			}else{
//				//Desactivar Facebook MSN
//			}
	}
}