package geo.profile.receiver;

import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import android.bluetooth.BluetoothAdapter;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.media.AudioManager;
import android.net.ConnectivityManager;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.provider.Settings;

public class AlarmReceiverFin extends BroadcastReceiver {
	@Override
	public void onReceive(Context arg0, Intent arg1) {
		
		restaurarPerfil(arg0, arg1);
	}
	
	public void restaurarPerfil(Context context, Intent intent){
		BluetoothAdapter mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
		
		//Obtenemos los extras del Intent
        Bundle bun = intent.getExtras();
        
        //Variables para ver el estado anterior
		
      		boolean vibrador_anterior = bun.getBoolean("vibrador_anterior");
      		boolean silencio_anterior = bun.getBoolean("silencio_anterior");
      		Integer volumen_anterior = bun.getInt("volumen_anterior");
      		boolean wifi_anterior = bun.getBoolean("wifi_anterior");
      		boolean tres_g_anterior = bun.getBoolean("tres_g_anterior");
      		boolean bluetooth_anterior = bun.getBoolean("bluetooth_anterior");
      		boolean modo_avion_anterior = bun.getBoolean("modo_avion_anterior");
      		
      		//Conocer el estado de los desvos de llamada es un trabajo de investigacin que no se
          	//ha podido completar dada su gran dificultad
      		
//      		boolean desvio_siempre_anterior;
//      		String telefono_siempre_anterior;
//      		boolean desvio_ocupada_anterior;
//      		String telefono_ocupada_anterior;
//      		boolean desvio_sin_respuesta_anterior;
//      		String telefono_sin_respuesta_anterior;
//      		String retraso_anterior;
//      		boolean desvio_sin_conexion_anterior;
//      		String telefono_sin_conexion_anterior;
      		
      		//Conocer el estado de las aplicaciones de mensajera instantnea no es posible
//      		boolean gtalk_anterior;
//      		boolean whatsapp_anterior;
//      		boolean facebook_msn_anterior;
      		
      	//Reestablecer los valores que haba antes de coincidir con la franja horaria
			
			//Wifi
			if(wifi_anterior){	//Estaba activado
				((WifiManager) context.getSystemService(Context.WIFI_SERVICE)).setWifiEnabled(true);
			}else{		//Estaba desactivado
				((WifiManager) context.getSystemService(Context.WIFI_SERVICE)).setWifiEnabled(false);
			}
			
			//Tres_G
			Boolean enabled;
			if(tres_g_anterior){ //Estaba activado
				enabled = true;
				final ConnectivityManager conman = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
			    Class<?> conmanClass;
				try {
					conmanClass = Class.forName(conman.getClass().getName());
					final Field iConnectivityManagerField = conmanClass.getDeclaredField("mService");
					iConnectivityManagerField.setAccessible(true);
					final Object iConnectivityManager = iConnectivityManagerField.get(conman);
					final Class<?> iConnectivityManagerClass = Class.forName(iConnectivityManager.getClass().getName());
					final Method setMobileDataEnabledMethod = iConnectivityManagerClass.getDeclaredMethod("setMobileDataEnabled", Boolean.TYPE);
					setMobileDataEnabledMethod.setAccessible(true);
					setMobileDataEnabledMethod.invoke(iConnectivityManager, enabled);
				} catch (ClassNotFoundException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (SecurityException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchFieldException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalArgumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchMethodException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}else{	//Estaba desactivado
				enabled = false;
				final ConnectivityManager conman = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
			    Class<?> conmanClass;
				try {
					conmanClass = Class.forName(conman.getClass().getName());
					final Field iConnectivityManagerField = conmanClass.getDeclaredField("mService");
					iConnectivityManagerField.setAccessible(true);
					final Object iConnectivityManager = iConnectivityManagerField.get(conman);
					final Class<?> iConnectivityManagerClass = Class.forName(iConnectivityManager.getClass().getName());
					final Method setMobileDataEnabledMethod = iConnectivityManagerClass.getDeclaredMethod("setMobileDataEnabled", Boolean.TYPE);
					setMobileDataEnabledMethod.setAccessible(true);
					setMobileDataEnabledMethod.invoke(iConnectivityManager, enabled);
				} catch (ClassNotFoundException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (SecurityException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchFieldException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalArgumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (NoSuchMethodException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			
			//Bluetooth
			if(bluetooth_anterior){	//Estaba activado
				if(mBluetoothAdapter != null){
					mBluetoothAdapter.enable();
				}
			} else {	//Estaba desactivado
				if(mBluetoothAdapter != null){
					mBluetoothAdapter.disable();
				}
			}
			
			//Modo avion
			if(modo_avion_anterior){	//Estaba activado
				Settings.System.putInt(context.getContentResolver(),Settings.System.AIRPLANE_MODE_ON, 1);
				//Broadcast Intent para informar
		        Intent intent_modo_avion = new Intent(Intent.ACTION_AIRPLANE_MODE_CHANGED);
		        intent_modo_avion.putExtra("state", modo_avion_anterior);
		        context.sendBroadcast(intent_modo_avion);

			}else{	//Estaba desactivado
				Settings.System.putInt(context.getContentResolver(),Settings.System.AIRPLANE_MODE_ON, 0);
				//Broadcast Intent para informar
		        Intent intent_modo_avion = new Intent(Intent.ACTION_AIRPLANE_MODE_CHANGED);
		        intent_modo_avion.putExtra("state", modo_avion_anterior);
		        context.sendBroadcast(intent_modo_avion);
		        
		        //Al desacivar el modo avin hay que introducir de nuevo el pin y para restaurar los valores
		        //anteriores es necesario leerlos de nuevo
		        //Wifi
				if(wifi_anterior){	//Estaba activado
					((WifiManager) context.getSystemService(Context.WIFI_SERVICE)).setWifiEnabled(true);
				}else{		//Estaba desactivado
					((WifiManager) context.getSystemService(Context.WIFI_SERVICE)).setWifiEnabled(false);
				}
				
				//Tres_G
				Boolean enabled1;
				if(tres_g_anterior){ //Estaba activado
					enabled1 = true;
					final ConnectivityManager conman = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
				    Class<?> conmanClass;
					try {
						conmanClass = Class.forName(conman.getClass().getName());
						final Field iConnectivityManagerField = conmanClass.getDeclaredField("mService");
						iConnectivityManagerField.setAccessible(true);
						final Object iConnectivityManager = iConnectivityManagerField.get(conman);
						final Class<?> iConnectivityManagerClass = Class.forName(iConnectivityManager.getClass().getName());
						final Method setMobileDataEnabledMethod = iConnectivityManagerClass.getDeclaredMethod("setMobileDataEnabled", Boolean.TYPE);
						setMobileDataEnabledMethod.setAccessible(true);
						setMobileDataEnabledMethod.invoke(iConnectivityManager, enabled1);
					} catch (ClassNotFoundException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} catch (SecurityException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (NoSuchFieldException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (IllegalArgumentException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (IllegalAccessException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (NoSuchMethodException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (InvocationTargetException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}else{	//Estaba desactivado
					enabled1 = false;
					final ConnectivityManager conman = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
				    Class<?> conmanClass;
					try {
						conmanClass = Class.forName(conman.getClass().getName());
						final Field iConnectivityManagerField = conmanClass.getDeclaredField("mService");
						iConnectivityManagerField.setAccessible(true);
						final Object iConnectivityManager = iConnectivityManagerField.get(conman);
						final Class<?> iConnectivityManagerClass = Class.forName(iConnectivityManager.getClass().getName());
						final Method setMobileDataEnabledMethod = iConnectivityManagerClass.getDeclaredMethod("setMobileDataEnabled", Boolean.TYPE);
						setMobileDataEnabledMethod.setAccessible(true);
						setMobileDataEnabledMethod.invoke(iConnectivityManager, enabled1);
					} catch (ClassNotFoundException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					} catch (SecurityException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (NoSuchFieldException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (IllegalArgumentException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (IllegalAccessException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (NoSuchMethodException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (InvocationTargetException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				
				//Bluetooth
				if(bluetooth_anterior){	//Estaba activado
					if(mBluetoothAdapter != null){
						mBluetoothAdapter.enable();
					}
				} else {	//Estaba desactivado
					if(mBluetoothAdapter != null){
						mBluetoothAdapter.disable();
					}
				}
			}
			
			//Sonido
			//Vibrador y Volumen
			if(silencio_anterior){	//Estaba en modo silencio
				((AudioManager) context.getSystemService(Context.AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_SILENT);
			}else{	//Estaba en modo normal
				((AudioManager) context.getSystemService(Context.AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_NORMAL);
				((AudioManager) context.getSystemService(Context.AUDIO_SERVICE)).setStreamVolume(AudioManager.STREAM_RING, volumen_anterior, AudioManager.FLAG_SHOW_UI);
			}
			if(vibrador_anterior){	//Estaba en modo vibrador
				((AudioManager) context.getSystemService(Context.AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_VIBRATE);
			}else {	//Estaba en modo normal
				((AudioManager) context.getSystemService(Context.AUDIO_SERVICE)).setRingerMode(AudioManager.RINGER_MODE_NORMAL);
				((AudioManager) context.getSystemService(Context.AUDIO_SERVICE)).setStreamVolume(AudioManager.STREAM_RING, volumen_anterior, AudioManager.FLAG_SHOW_UI);
			}
			
			//Tono de llamada (no implementado en esta version)
			
			//Contestador (es lo mismo que el desvo de llamadas)
			
			//Desvos de llamadas (No se restaura al valor anterior dado que no es posible conocer el
			//estado anterior
			
			//Desvio Siempre
//			if(desvio_siempre_anterior){	//Estaba activado
//				String numero = telefono_siempre_anterior;
//				String callForwardString = "**21*"+numero+"#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);
//				intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				context.startActivity(intentCallForward); 
//				
//			}else{
//				String callForwardString = "##21#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL); 
//				intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				context.startActivity(intentCallForward); 
//				
//			}
//			//Desvio Ocupada
//			if(desvio_ocupada_anterior){	//Estaba activado
//				String numero = telefono_ocupada_anterior;
//				String callForwardString = "**67*"+numero+"#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);    
//				intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				startActivity(intentCallForward); 
//			}else{
//				String callForwardString = "##67#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL); 
//				intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				context.startActivity(intentCallForward); 
//			}
//			//Desvio Sin Respuesta
//			if(desvio_sin_respuesta_anterior){	//Estaba activado
//				String numero = telefono_sin_respuesta_anterior;
//				String retraso = retraso_anterior;
//				String callForwardString = "**61*"+numero+"**"+retraso+"#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);   
//				intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				context.startActivity(intentCallForward); 
//			}else{
//				String callForwardString = "##61#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);  
//				intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				context.startActivity(intentCallForward); 
//			}
//			//Desvio Sin Conexion
//			if(desvio_sin_conexion_anterior){	//Estaba activado
//				String numero = telefono_sin_conexion_anterior;
//				String callForwardString = "**62*"+numero+"#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);   
//				intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				context.startActivity(intentCallForward); 
//			}else{
//				String callForwardString = "##62#";    
//				Intent intentCallForward = new Intent(Intent.ACTION_CALL);  
//				intentCallForward.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
//				Uri uri2 = Uri.fromParts("tel", callForwardString, "#"); 
//				intentCallForward.setData(uri2);                                
//				context.startActivity(intentCallForward); 
//			}
			
			//Mensajera instantnea (No se restaura el estado anterior dado que no se puede conocer)
//			//GTalk
//			if(gtalk_anterior){	//Estaba activado
//				//Activar GTalk
//			}else{
//				//Desactivar GTalk
//			}
//			//WhatsApp
//			if(whatsapp_anterior){	//Estaba activado
//				//Activar WhatsApp
//			}else{
//				//Desactivar WhatsApp
//			}
//			//Facebook MSN
//			if(facebook_msn_anterior){	//Estaba activado
//				//Activar Facebook MSN
//			}else{
//				//Desactivar Facebook MSN
//			}
	}
}