package geo.profile.view;

import geo.profile.Perfil;
import geo.profile.R;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.provider.Settings;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

public class ConfigurarPorLocalizacionActivity extends Activity {
	
	final String[] datos = new String[]{"Activar/Desactivar GPS", "Repetir"};
	Integer idPerfil;

	//Declaramos las variables necesarias para el GPS
	private TextView lblLatitud; 
	private TextView lblLongitud;
	private TextView lblEstado;
	
	double longitud;
	double latitud;
	double radio;
	
	CheckBox chkPorLocalizacion;
	EditText edtRadioLocalizacion;
	ListView listaGPS;
	Button btnGuardarPorLocalizacion;
	
	private LocationManager locManager;
	private LocationListener locListener;
	
	Perfil perfil;
	private static final int DIALOGO_ALERTA_GPS = 9;
	private static final int DIALOGO_ALERTA_RADIO_GPS = 10;

	Double[] por_gps;
	
    @Override
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.configurarporlocalizacion);
        
        //Obtenemos el id (extra en el intent)
        Bundle bun = this.getIntent().getExtras();
        idPerfil = bun.getInt("id");
        
        //Checkbox Configurar por localizacion
	    
	    chkPorLocalizacion = (CheckBox)findViewById(R.id.ChkPorLocalizacion);
	    //chkPorLocalizacion.setChecked(false);
	    
	    edtRadioLocalizacion = (EditText)findViewById(R.id.EdtRadioLocalizacion);
	    edtRadioLocalizacion.setEnabled(false);
	    
	    //ListaGPS
	    
	    ArrayAdapter<String> adaptador =
			    new ArrayAdapter<String>(this,android.R.layout.simple_list_item_1, datos);
	    
	    listaGPS = (ListView)findViewById(R.id.ListaGPS);
	    listaGPS.setEnabled(false);
			 
	    listaGPS.setAdapter(adaptador);
			
	    listaGPS.setOnItemClickListener(new OnItemClickListener() {
		    public void onItemClick(AdapterView<?> a, View v, int position, long id) {
		    	
		    	if(position == 0){	//Activar o Desactivar GPS
		    		Intent intent = new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS);
		    		LocationManager servicio = (LocationManager) getSystemService(LOCATION_SERVICE);
					Boolean activado = servicio.isProviderEnabled(LocationManager.GPS_PROVIDER);
					if (!activado) {
						lblEstado.setText("GPS est desactivado");
					} else {
						lblEstado.setText("GPS est activado");
					}
					
					intent.putExtra("id", idPerfil);
		    		startActivity(intent);
					comenzarLocalizacion();
		    		
		    	}else if(position == 1){	//Repetir
		    		Intent intent = new Intent(ConfigurarPorLocalizacionActivity.this, RepetirActivity.class);
		    		intent.putExtra("id", idPerfil);
		    		intent.putExtra("repetir", "gps");
		    		startActivity(intent);
		    	}
		   	}
	    });
	    
	    chkPorLocalizacion.setOnCheckedChangeListener(
	        new CheckBox.OnCheckedChangeListener() {
	            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
	                if (isChecked) {
	                	listaGPS.setEnabled(true);
	                	edtRadioLocalizacion.setEnabled(true);
	                }
	                else {
	                	listaGPS.setEnabled(false);
	                	edtRadioLocalizacion.setEnabled(false);
		            }
		        }
		    });
	    
	    //TextView de Longitud, Latitud y Estado
        
        lblLatitud = (TextView)findViewById(R.id.LblPosLatitud);
        lblLongitud = (TextView)findViewById(R.id.LblPosLongitud);
        lblEstado = (TextView)findViewById(R.id.LblEstado);
        
      //Obtenemos los datos de Localizacion de la BD
        perfil = new Perfil();
    	perfil.loadPerfil(ConfigurarPorLocalizacionActivity.this,idPerfil);
    	por_gps = perfil.buscarPorLocalizacion(this);
    	
    	if(por_gps[0] == 1){
        	chkPorLocalizacion.setChecked(true);
        	listaGPS.setEnabled(true);
        	edtRadioLocalizacion.setEnabled(true);
        }else{
        	chkPorLocalizacion.setChecked(false);
        	listaGPS.setEnabled(false);
        	edtRadioLocalizacion.setEnabled(false);
        }
    	
    	if(por_gps[1] != null){	//Radio
    		radio = (por_gps[1]);
    		edtRadioLocalizacion.setText(por_gps[1].toString());
        }
    	
    	if(por_gps[2] != null){	//Longitud
    		longitud = (por_gps[2]);
    		if(longitud != 0){
    			lblLongitud.setText(por_gps[2].toString());
    		}
        }
    	
    	if(por_gps[3] != null){	//Latitud
    		latitud = (por_gps[3]);
    		if(latitud != 0){
    			lblLatitud.setText(por_gps[3].toString());
    		}
        }
        
        //Botn Guardar
	    
	    btnGuardarPorLocalizacion = (Button)findViewById(R.id.BtnGuardarPorLocalizacion);
	    
	    btnGuardarPorLocalizacion.setOnClickListener(new View.OnClickListener() {
	        public void onClick(View arg0)
	        {
	        	guardarPorLocalizacion(arg0);
	        }
	    });

    }
    
    public void guardarPorLocalizacion(View v){
    	
    	perfil = new Perfil();
    	perfil.loadPerfil(ConfigurarPorLocalizacionActivity.this,idPerfil);
    	
    	if(!edtRadioLocalizacion.getText().toString().equals(R.string.radioLocalizacion) && !edtRadioLocalizacion.getText().toString().equals("")){
    		
    		try {
				radio = Double.parseDouble(edtRadioLocalizacion.getText().toString());
			}catch (NumberFormatException e) {
				// TODO Auto-generated catch block
				showDialog(DIALOGO_ALERTA_RADIO_GPS);
				e.printStackTrace();
			} 
    	}
    	
    	if(!lblLongitud.getText().toString().equals("") && !lblLatitud.getText().toString().equals("")){
    		try{
    			longitud = Double.parseDouble(lblLongitud.getText().toString());
    			latitud = Double.parseDouble(lblLatitud.getText().toString());
    		}catch (NumberFormatException e) {
				// TODO Auto-generated catch block
				showDialog(DIALOGO_ALERTA_GPS);
				e.printStackTrace();
			} 
		    
    	}
    	
    	if(chkPorLocalizacion.isChecked()){
    		perfil.setPorGps(1);
    		if(edtRadioLocalizacion.getText().toString().equals("")){
    			showDialog(DIALOGO_ALERTA_RADIO_GPS);
    		}else{
    			perfil.setRadio(radio);
    		}
    		if(lblLongitud.getText().toString().equals("Sin datos") || lblLatitud.getText().toString().equals("Sin datos")
    				|| lblLongitud.getText().toString().equals("") || lblLatitud.getText().toString().equals("")){
    			showDialog(DIALOGO_ALERTA_GPS);
    		}else{
				perfil.setLongitud(longitud);
				perfil.setLatitud(latitud);
    			finish();
    		}
    	}else{
    		perfil.setPorGps(0);
    		finish();
    	}
    	
    	perfil.updatePerfilPorLocalizacion(this);
    }
    
    @Override
	protected Dialog onCreateDialog(int id) {
	    switch (id) {
	    case DIALOGO_ALERTA_GPS:
			return crearDialogoAlertaGps();
	    case DIALOGO_ALERTA_RADIO_GPS:
	    	return crearDialogoAlertaRadioGps();
	    }
	    return null;
	}
	
	 private Dialog crearDialogoAlertaGps()
	    {
	        AlertDialog.Builder builder = new AlertDialog.Builder(this);
	     
	        builder.setTitle("Error");
	        builder.setMessage("No se puede guardar si no hay datos de la posicin GPS.");
	        builder.setPositiveButton("OK", new OnClickListener() {
	            public void onClick(DialogInterface dialog, int which) {
	                dialog.cancel();
	            }
	        });
	     
	        return builder.create();
	    }
	 
	 private Dialog crearDialogoAlertaRadioGps()
	    {
	        AlertDialog.Builder builder = new AlertDialog.Builder(this);
	     
	        builder.setTitle("Error");
	        builder.setMessage("Es necesario introducir un radio en metros.");
	        builder.setPositiveButton("OK", new OnClickListener() {
	            public void onClick(DialogInterface dialog, int which) {
	                dialog.cancel();
	            }
	        });
	     
	        return builder.create();
	    }
    
    private void comenzarLocalizacion()
    {
    	//Obtenemos una referencia al LocationManager
    	locManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
    	
    	//Obtenemos la ltima posicin conocida
    	Location loc = locManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
    	
    	//Mostramos la ltima posicin conocida
    	mostrarPosicion(loc);
    	
    	//Nos registramos para recibir actualizaciones de la posicin
    	locListener = new LocationListener() {
	    	public void onLocationChanged(Location location) {
	    		mostrarPosicion(location);
	    	}
	    	public void onProviderDisabled(String provider){
	    		lblEstado.setText("GPS est desactivado");
	    	}
	    	public void onProviderEnabled(String provider){
	    		lblEstado.setText("GPS est activado");
	    	}
	    	public void onStatusChanged(String provider, int status, Bundle extras){
	    		Log.i("", "Provider Status: " + status);
	    		if(status == 0){	//OUT_OF_SERVICE 
	    			lblEstado.setText("Estado del proveedor GPS: Fuera de servicio");
	    		}else if(status == 1){	//TEMPORARILY_UNAVAILABLE 
	    			lblEstado.setText("Estado del proveedor GPS: No disponible temporalmente");
	    		}else if(status == 2){	//AVAILABLE
	    			lblEstado.setText("Estado del proveedor GPS: Disponible");
	    		}
	    	}
    	};
    	
    	locManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 60000, 100, locListener);
    }
     
    private void mostrarPosicion(Location loc) {
    	if(loc != null)
    	{
    		lblLatitud.setText(String.valueOf(loc.getLatitude()));
    		lblLongitud.setText(String.valueOf(loc.getLongitude()));
    		Log.i("", String.valueOf(loc.getLatitude() + " - " + String.valueOf(loc.getLongitude())));
    	}
    	else
    	{
    		lblLatitud.setText("Sin datos");
    		lblLongitud.setText("Sin datos");
    	}
    }
}