package geo.profile.view;

import geo.profile.Perfil;
import geo.profile.R;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

public class EditarPerfilSeleccionadoActivity extends Activity {
	TextView textViewNombrePerfil;
	String nombre;
	ListView listaEditarPerfilSeleccionado;
	EditText edtNombrePerfil;
	Editable nombreIntroducido;
	Button btnEditarNombrePerfil;
	Integer idPerfil;
	public  Perfil perfil;
	
	final String[] datos =
		    new String[]{"Configurar segn la hora", "Configurar segn la localizacin", "Sonido", 
		    		"Conexiones inalmbricas", "Modo avin", "Contestador", "Mensajera instantnea"};
	
	private static final int DIALOGO_ALERTA_NOMBRE = 12;
	private static final int DIALOGO_ALERTA_NOMBRE_REPETIDO = 13;
	
		 
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.editarperfilseleccionado);
        
        //Obtenemos el id (extra en el intent)
        Bundle bun = this.getIntent().getExtras();
        idPerfil = bun.getInt("id");
        nombre = bun.getString("nombre");
        
        perfil = new Perfil();
		perfil.loadPerfil(EditarPerfilSeleccionadoActivity.this, idPerfil);
		
		//Nombre del perfil
        
		textViewNombrePerfil = (TextView)findViewById(R.id.TextViewNombrePerfil);
       	textViewNombrePerfil.setText(nombre);
	       	
		//Nombre introducido
        
        edtNombrePerfil = (EditText)findViewById(R.id.EdtNombrePerfil);
        edtNombrePerfil.setText(nombre);
       	nombreIntroducido = edtNombrePerfil.getText();
       	
       	//Boton Siguiente
       	btnEditarNombrePerfil = (Button)findViewById(R.id.BtnEditarNombrePerfil);
    	
       	btnEditarNombrePerfil.setOnClickListener(new View.OnClickListener() {
        	public void onClick(View v) {
        		
        		updatePerfil(v);
        		
        		Perfil perfil = new Perfil();
        		perfil.loadPerfil(EditarPerfilSeleccionadoActivity.this, idPerfil);
        	}
        }); 
		
        //Lista de crear perfil
        
        ArrayAdapter<String> adaptador =
    		    new ArrayAdapter<String>(this,android.R.layout.simple_list_item_1, datos);
        
        listaEditarPerfilSeleccionado = (ListView)findViewById(R.id.ListaEditarPerfilSeleccionado);
    		 
        listaEditarPerfilSeleccionado.setAdapter(adaptador);
    		
        listaEditarPerfilSeleccionado.setOnItemClickListener(new OnItemClickListener() {
		    public void onItemClick(AdapterView<?> a, View v, int position, long id) {
		    	
		    	if(position == 0){	//Configurar segn la hora
		    	
			    	Intent intent = new Intent(EditarPerfilSeleccionadoActivity.this, ConfigurarPorHoraActivity.class);
					intent.putExtra("id", idPerfil);
					startActivity(intent);
				
		    	}else if(position == 1){	//Configurar segn la localizacin
					
		    		Intent intent = new Intent(EditarPerfilSeleccionadoActivity.this, ConfigurarPorLocalizacionActivity.class);
		    		intent.putExtra("id", idPerfil);					
					startActivity(intent);
					
		    	}else if(position == 2){	//Sonido
					
		    		Intent intent = new Intent(EditarPerfilSeleccionadoActivity.this, SonidoActivity.class);
		    		intent.putExtra("id", idPerfil);
					startActivity(intent);
					
		    	}else if(position == 3){	//Conexiones inalmbricas
					
		    		Intent intent = new Intent(EditarPerfilSeleccionadoActivity.this, ConexionesInalambricasActivity.class);
		    		intent.putExtra("id", idPerfil);
					startActivity(intent);
					
		    	}else if(position == 4){	//Modo avin
					
		    		Intent intent = new Intent(EditarPerfilSeleccionadoActivity.this, ModoAvionActivity.class);
		    		intent.putExtra("id", idPerfil);
					startActivity(intent);
					
		    	}else if(position == 5){	//Contestador
					
		    		Intent intent = new Intent(EditarPerfilSeleccionadoActivity.this, ContestadorActivity.class);
		    		intent.putExtra("id", idPerfil);
					startActivity(intent);
					
		    	}else if(position == 6){	//Mensajera instantnea
					
		    		Intent intent = new Intent(EditarPerfilSeleccionadoActivity.this, MensajeriaInstantaneaActivity.class);
		    		intent.putExtra("id", idPerfil);
					startActivity(intent);
	
		    	}
		    }
    	});
		
	}
    
    //Actualizar el perfil actual
    public void updatePerfil(View view) {
    	
    	if (nombreIntroducido.toString().equals("")){
    		showDialog(DIALOGO_ALERTA_NOMBRE);
    	}else{
    		
    		perfil.loadPerfil(this, idPerfil);
    		
    		boolean existeNombre = perfil.getNombreRepetido(this, nombreIntroducido.toString());
    		
    		if(existeNombre){
				showDialog(DIALOGO_ALERTA_NOMBRE_REPETIDO);
				if(idPerfil != null){
				}
    		}else{
    			perfil.setNombre(nombreIntroducido.toString());
    	    	
    	    	perfil.updatePerfil(this);	
    	    	idPerfil = perfil.getId();
    	    	
    	    	//Nombre del perfil
    	        
    	       	textViewNombrePerfil.setText(nombreIntroducido);
    		}
    	}
        
    }
    
    
    @Override
	protected Dialog onCreateDialog(int id) {
    	Dialog dialogo = null;

    	switch(id)
    	{
    		case DIALOGO_ALERTA_NOMBRE:
    			dialogo = crearDialogoAlertaNombre();
    			break;
    		case DIALOGO_ALERTA_NOMBRE_REPETIDO:
    			dialogo = crearDialogoAlertaNombreRepetido();
    			break;
    		default:
    			dialogo = null;
    			break;
    	}
    
    	return dialogo;
    }

    
    private Dialog crearDialogoAlertaNombre()
    {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
     
        builder.setTitle("Error");
        builder.setMessage("Debe introducir un nombre antes de continuar.");
        builder.setPositiveButton("OK", new OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
                dialog.cancel();
            }
        });
     
        return builder.create();
    }
    
    private Dialog crearDialogoAlertaNombreRepetido()
    {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
     
        builder.setTitle("Error");
        builder.setMessage("Ya existe un perfil con ese nombre. Introduzca un nombre distinto.");
        builder.setPositiveButton("OK", new OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
                dialog.cancel();
            }
        });
     
        return builder.create();
    }
}