package geo.profile.view;

import geo.profile.Perfil;
import geo.profile.R;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ListView;
import android.widget.TextView;

public class RepetirActivity extends Activity {
	
	private ListView listaRepetir;
	private mItems[] elementos;
	private ArrayAdapter<mItems> listAdapter;
	static ArrayList<String> dias_repetir;
	Integer idPerfil;
	String repetir;
	Perfil perfil;
	String [] cadenaRepetir;
	String [] split_repetir;
	String dia;
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.repetir);
		
		//Reseteamos dia
		dia = new String();
		
		//Reseteamos dias_repetir
		dias_repetir = new ArrayList<String>();
		
		//Obtenemos el id (extra en el intent)
        Bundle bun = this.getIntent().getExtras();
        idPerfil = bun.getInt("id");
        
        //Obtenemos el valor de "repetir" (extra en el intent)
        repetir = bun.getString("repetir");
        
        //Obtenemos los datos de Repetir de la BD
        perfil = new Perfil();
    	perfil.loadPerfil(RepetirActivity.this,idPerfil);
    	cadenaRepetir = perfil.buscarRepetir(this);
    	
    	if(repetir.equals("hora")){
    		if(cadenaRepetir[0] != null){
    			String cadenaRepetirSinCorchetes = cadenaRepetir[0].substring(1, cadenaRepetir[0].length() - 1);
    			split_repetir = cadenaRepetirSinCorchetes.split(", ");
    		}
    	}else if(repetir.equals("gps")){
    		if(cadenaRepetir[1] != null){
    			String cadenaRepetirSinCorchetes = cadenaRepetir[1].substring(1, cadenaRepetir[1].length() - 1);
    			split_repetir = cadenaRepetirSinCorchetes.split(", ");
    		}
    	}
    	
		//Lista Repetir
		listaRepetir = (ListView) findViewById(R.id.ListaRepetir);

		listaRepetir.setOnItemClickListener(new AdapterView.OnItemClickListener() {
					public void onItemClick(AdapterView<?> parent, View item, int position, long id) {
						mItems planet = listAdapter.getItem(position);
						planet.toggleChecked();
						SelectViewHolder viewHolder = (SelectViewHolder) item.getTag();
						viewHolder.getCheckBox().setChecked(planet.isChecked());
					}
				});

		elementos = (mItems[]) getLastNonConfigurationInstance();
		ArrayList<mItems> planetList = new ArrayList<mItems>();

		planetList.add(new mItems("Lunes"));
		planetList.add(new mItems("Martes"));
		planetList.add(new mItems("Miercoles"));
		planetList.add(new mItems("Jueves"));
		planetList.add(new mItems("Viernes"));
		planetList.add(new mItems("Sabado"));
		planetList.add(new mItems("Domingo"));
		
		Iterator<mItems> it = planetList.iterator();
		if(it.hasNext()){
			while(it.hasNext()){
				mItems elem = it.next();
				if(split_repetir != null){
			    	for(int i = 0; i < split_repetir.length; i++){
						dia = split_repetir[i];
						if(dia.equals(elem.getName())){
							elem.setChecked(true);
							dias_repetir.add(dia);
						}
			    	}
				}
			}
		}
		
		
		listAdapter = new SelectArralAdapter(this, planetList);
		listaRepetir.setAdapter(listAdapter);
		
		//Botn Guardar
	    
	    final Button btnGuardarDiasRepetir = (Button)findViewById(R.id.BtnGuardarDiasRepetir);
	    
	    btnGuardarDiasRepetir.setOnClickListener(new View.OnClickListener() {
	        public void onClick(View arg0)
	        {
		        guardarRepetir(arg0,repetir);
	        }
	    });
	}
	
	public void guardarRepetir(View v, String repet){
    	
    	perfil = new Perfil();
    	perfil.loadPerfil(RepetirActivity.this,idPerfil);
    	
    	if(repetir.equals("hora")){
    		perfil.setDiasRepeticionHoras(dias_repetir.toString());
    	}else if(repetir.equals("gps")){
    		perfil.setDiasRepeticionGps(dias_repetir.toString());
    	}
    	
    		finish();
    	
    	perfil.updatePerfilRepetir(this);
    }
	
	public static class mItems {
		private String name = "";
		private boolean checked = false;

		public mItems() {
		}

		public mItems(String name) {
			this.name = name;
		}

		public mItems(String name, boolean checked) {
			this.name = name;
			this.checked = checked;
		}

		public String getName() {
			return name;
		}

		public void setName(String name) {
			this.name = name;
		}

		public boolean isChecked() {
			return checked;
		}

		public void setChecked(boolean checked) {
			this.checked = checked;
		}

		@Override
		public String toString() {
			return name;
		}

		public void toggleChecked() {
			checked = !checked;
		}
	}

	/** Holds child views for one row. */
	private static class SelectViewHolder {
		private CheckBox checkBox;
		private TextView textView;

		@SuppressWarnings("unused")
		public SelectViewHolder() {
		}

		public SelectViewHolder(TextView textView, CheckBox checkBox) {
			this.checkBox = checkBox;
			this.textView = textView;
		}

		public CheckBox getCheckBox() {
			return checkBox;
		}

		@SuppressWarnings("unused")
		public void setCheckBox(CheckBox checkBox) {
			this.checkBox = checkBox;
		}

		public TextView getTextView() {
			return textView;
		}

		@SuppressWarnings("unused")
		public void setTextView(TextView textView) {
			this.textView = textView;
		}
	}

	/** Custom adapter for displaying an array of Planet objects. */
	private static class SelectArralAdapter extends ArrayAdapter<mItems> {
		private LayoutInflater inflater;

		public SelectArralAdapter(Context context, List<mItems> planetList) {
			super(context, R.layout.repetir_fila, R.id.TextViewRepetirFila, planetList);
			// Cache the LayoutInflate to avoid asking for a new one each time.
			inflater = LayoutInflater.from(context);
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			// Planet to display
			mItems planet = this.getItem(position);

			// The child views in each row.
			CheckBox checkBox;
			TextView textView;

			// Create a new row view
			if (convertView == null) {
				convertView = inflater.inflate(R.layout.repetir_fila, null);

				// Find the child views.
				textView = (TextView) convertView
						.findViewById(R.id.TextViewRepetirFila);
				checkBox = (CheckBox) convertView.findViewById(R.id.ChkBoxRepetirFila);
				// Optimization: Tag the row with it's child views, so we don't
				// have to
				// call findViewById() later when we reuse the row.
				convertView.setTag(new SelectViewHolder(textView, checkBox));
				// If CheckBox is toggled, update the planet it is tagged with.
				checkBox.setOnClickListener(new View.OnClickListener() {
					public void onClick(View v) {
						CheckBox cb = (CheckBox) v;
						mItems planet = (mItems) cb.getTag();
						planet.setChecked(cb.isChecked());
						
						if(cb.isChecked()){
							dias_repetir.add(cb.getTag().toString());
						}else{
							dias_repetir.remove(cb.getTag().toString());
						}
					}
				});
			}
			// Reuse existing row view
			else {
				// Because we use a ViewHolder, we avoid having to call
				// findViewById().
				SelectViewHolder viewHolder = (SelectViewHolder) convertView
						.getTag();
				checkBox = viewHolder.getCheckBox();
				textView = viewHolder.getTextView();
			}

			// Tag the CheckBox with the Planet it is displaying, so that we can
			// access the planet in onClick() when the CheckBox is toggled.
			checkBox.setTag(planet);
			// Display planet data
			checkBox.setChecked(planet.isChecked());
			textView.setText(planet.getName());
			return convertView;
		}
	}

	@Override
	public Object onRetainNonConfigurationInstance() {
		return elementos;
	}
}